## ucar.multiarray
Class ArrayMultiArray

    java.lang.Object
      ucar.multiarray.ArrayMultiArray

All Implemented Interfaces:
  Accessor, MultiArray, MultiArrayInfo

public class ArrayMultiArray
extends Object
implements MultiArray

MultiArray implementation which is an adapter for java language arrays. If you have a java array and want to wrap it in a MultiArray interface, use this class. Rank of these is always > 0, use ScalarMultiArray for scalars.

The set, setXXX, get, getXXX methods use the corresponding methods from java.lang.reflect.Array, the conversion and exception characteristics of the methods here are like the ones found there.

See Also:
  `Array`, `MultiArray`, `ScalarMultiArray`

Field Summary
`Object` `jla` The java language array which this adapts.

Constructor Summary
`` `ArrayMultiArray(Class componentType, int[] dimensions)` Create a new MultiArray of the given componentType and shape.
`` `ArrayMultiArray(MultiArray ma)` A copy constructor.
`` `ArrayMultiArray(Object aro)` Given a java Object, typically an array of primitive (or an array of array of primitive ...), Provide a MultiArray interface to the provided object.
`(package private)` `ArrayMultiArray(Object aro, int theRank, Class componentType)` Package private constructor which avoids some of the protections of the public constructor below.

Method Summary
`void` `copyin(int[] origin, MultiArray data)` Aggregate write access.
`MultiArray` `copyout(int[] origin, int[] shape)` Aggregate read access.
`Object` `get(int index)` Peel the array by fixing the leftmost index value to the argument.
`Object` `get(int[] index)` Get (read) the array element at index.
`boolean` `getBoolean(int[] index)` Get the array element at index, as a boolean.
`byte` `getByte(int[] index)` Get the array element at index, as a byte.
`char` `getChar(int[] index)` Get the array element at index, as a char.
`Class` `getComponentType()` Returns the Class object representing the component type of the wrapped array.
`double` `getDouble(int[] index)` Get the array element at index, as a double.
`float` `getFloat(int[] index)` Get the array element at index, as a float.
`int` `getInt(int[] index)` Get the array element at index, as an int.
`Object` `getLeaf(int[] index)` Get the leaf array at Index.
`int[]` `getLengths()` As if java.lang.reflect.Array.getLength() were called recursively on the wrapped object, return the dimension lengths.
`long` `getLong(int[] index)` Get the array element at index, as a long.
`int` `getRank()` Returns the number of dimensions of the array.
`short` `getShort(int[] index)` Get the array element at index, as a short.
`Object` `getStorage()`
`boolean` `isScalar()` Always returns false for this class.
`boolean` `isUnlimited()` Returns `true` if and only if the effective dimension lengths can change.
`static void` `main(String[] args)`
`void` `set(int[] index, Object value)` Set (modify, write) the array element at index to the specified value.
`void` `setBoolean(int[] index, boolean value)` Set the array element at index to the specified boolean value.
`void` `setByte(int[] index, byte value)` Set the array element at index to the specified byte value.
`void` `setChar(int[] index, char value)` Set the array element at index to the specified char value.
`void` `setDouble(int[] index, double value)` Set the array element at index to the specified double value.
`void` `setFloat(int[] index, float value)` Set the array element at index to the specified float value.
`void` `setInt(int[] index, int value)` Set the array element at index to the specified int value.
`void` `setLong(int[] index, long value)` Set the array element at index to the specified long value.
`void` `setShort(int[] index, short value)` Set the array element at index to the specified short value.
`Object` `toArray()` Returns a new array containing all of the elements in this MultiArray.
`Object` `toArray(Object dst, int[] origin, int[] shape)` Returns an array containing elements of this MultiArray specified by origin and shape, possibly converting the component type.
`(package private) static int[]` `truncCopy(int[] src)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### jla

    public final Object jla

  The java language array which this adapts.

Constructor Detail

### ArrayMultiArray

    ArrayMultiArray(Object aro,
                    int theRank,
                    Class componentType)

  Package private constructor which avoids some of the protections of the public constructor below.

### ArrayMultiArray

    public ArrayMultiArray(Object aro)

  Given a java Object, typically an array of primitive (or an array of array of primitive ...), Provide a MultiArray interface to the provided object. The wrapper provided does not copy the object, so it remains accessable via the language [] notation and the java.lang.reflect.Array methods. Synchronization not provided by this interface.

Parameters:
  `aro` - a (multi-dimensional) array of primitives.

### ArrayMultiArray

    public ArrayMultiArray(Class componentType,
                           int[] dimensions)

  Create a new MultiArray of the given componentType and shape. Storage for the values is allocated and owned by this with default initialization.

Parameters:
  `componentType` - Class of the primitives or objects to be contained.
  `dimensions` - the shape of the MultiArray. dimensions.length determines the rank of the new MultiArray.

### ArrayMultiArray

    public ArrayMultiArray(MultiArray ma)
                    throws IOException

  A copy constructor.

  Create a new MultiArray with the same componentType and shape as the argument

Parameters:
  `ma` - the MultiArray to copy.

Method Detail

### getComponentType

    public Class getComponentType()

  Returns the Class object representing the component type of the wrapped array. If the rank is greater than 1, this will be the component type of the leaf (rightmost) nested array.

  Specified by:
    `getComponentType` in interface `MultiArrayInfo`
  Returns:
    Class the component type
  See Also:
    `MultiArrayInfo.getComponentType()`

### getRank

    public int getRank()

  Description copied from interface: `MultiArrayInfo`
  Returns the number of dimensions of the array.

  Specified by:
    `getRank` in interface `MultiArrayInfo`
  Returns:
    int number of dimensions of the array
  See Also:
    `MultiArrayInfo.getRank()`

### getLengths

    public int[] getLengths()

  As if java.lang.reflect.Array.getLength() were called recursively on the wrapped object, return the dimension lengths.

  Specified by:
    `getLengths` in interface `MultiArrayInfo`
  Returns:
    int array whose length is the rank of this MultiArray and whose elements represent the length of each of it's dimensions
  See Also:
    `MultiArrayInfo.getLengths()`

### isUnlimited

    public boolean isUnlimited()

  Returns `true` if and only if the effective dimension lengths can change. Always returns `false` for this class.

  Specified by:
    `isUnlimited` in interface `MultiArrayInfo`
  Returns:
    boolean `false`
  See Also:
    `MultiArrayInfo.isUnlimited()`

### isScalar

    public boolean isScalar()

  Always returns false for this class.

  Specified by:
    `isScalar` in interface `MultiArrayInfo`
  Returns:
    false
  See Also:
    `MultiArrayInfo.isScalar()`

### get

    public Object get(int[] index)

  Description copied from interface: `Accessor`
  Get (read) the array element at index. The returned value is wrapped in an object if it has a primitive type. Length of index must be greater than or equal to the rank of this. Values of index components must be less than corresponding values from getLengths().

  Specified by:
    `get` in interface `Accessor`
  Parameters:
    `index` - MultiArray index
  Returns:
    Object value at `index`
  See Also:
    `Accessor.get(int[])`

### getBoolean

    public boolean getBoolean(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as a boolean.

  Specified by:
    `getBoolean` in interface `Accessor`
  See Also:
    `Accessor.getBoolean(int[])`

### getChar

    public char getChar(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as a char.

  Specified by:
    `getChar` in interface `Accessor`
  See Also:
    `Accessor.getChar(int[])`

### getByte

    public byte getByte(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as a byte.

  Specified by:
    `getByte` in interface `Accessor`
  See Also:
    `Accessor.getByte(int[])`

### getShort

    public short getShort(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as a short.

  Specified by:
    `getShort` in interface `Accessor`
  See Also:
    `Accessor.getShort(int[])`

### getInt

    public int getInt(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as an int.

  Specified by:
    `getInt` in interface `Accessor`
  See Also:
    `Accessor.getInt(int[])`

### getLong

    public long getLong(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as a long.

  Specified by:
    `getLong` in interface `Accessor`
  See Also:
    `Accessor.getLong(int[])`

### getFloat

    public float getFloat(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as a float.

  Specified by:
    `getFloat` in interface `Accessor`
  See Also:
    `Accessor.getFloat(int[])`

### getDouble

    public double getDouble(int[] index)

  Description copied from interface: `Accessor`
  Get the array element at index, as a double.

  Specified by:
    `getDouble` in interface `Accessor`
  See Also:
    `Accessor.getDouble(int[])`

### set

    public void set(int[] index,
                    Object value)

  Description copied from interface: `Accessor`
  Set (modify, write) the array element at index to the specified value. If the array has a primitive component type, the value may be unwrapped. Values of index components must be less than corresponding values from getLengths().

  Specified by:
    `set` in interface `Accessor`
  Parameters:
    `index` - MultiArray index
    `value` - the new value.
  See Also:
    `Accessor.set(int[], java.lang.Object)`

### setBoolean

    public void setBoolean(int[] index,
                           boolean value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified boolean value.

  Specified by:
    `setBoolean` in interface `Accessor`
  See Also:
    `Accessor.setBoolean(int[], boolean)`

### setChar

    public void setChar(int[] index,
                        char value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified char value.

  Specified by:
    `setChar` in interface `Accessor`
  See Also:
    `Accessor.setChar(int[], char)`

### setByte

    public void setByte(int[] index,
                        byte value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified byte value.

  Specified by:
    `setByte` in interface `Accessor`
  See Also:
    `Accessor.setByte(int[], byte)`

### setShort

    public void setShort(int[] index,
                         short value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified short value.

  Specified by:
    `setShort` in interface `Accessor`
  See Also:
    `Accessor.setShort(int[], short)`

### setInt

    public void setInt(int[] index,
                       int value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified int value.

  Specified by:
    `setInt` in interface `Accessor`
  See Also:
    `Accessor.setInt(int[], int)`

### setLong

    public void setLong(int[] index,
                        long value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified long value.

  Specified by:
    `setLong` in interface `Accessor`
  See Also:
    `Accessor.setLong(int[], long)`

### setFloat

    public void setFloat(int[] index,
                         float value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified float value.

  Specified by:
    `setFloat` in interface `Accessor`
  See Also:
    `Accessor.setFloat(int[], float)`

### setDouble

    public void setDouble(int[] index,
                          double value)

  Description copied from interface: `Accessor`
  Set the array element at index to the specified double value.

  Specified by:
    `setDouble` in interface `Accessor`
  See Also:
    `Accessor.setDouble(int[], double)`

### copyout

    public MultiArray copyout(int[] origin,
                              int[] shape)

  Description copied from interface: `Accessor`
  Aggregate read access. Return a new MultiArray of the same componentType as this, and with shape as specified, which is initialized to the values of this, as clipped to (origin, origin + shape).

  It is easier to implement than to specify :-).

  The main reason to implement this instead of using the equivalent proxy is for remote or file access.

  `assert(origin[ii] + shape[ii] <= lengths[ii]);`

  Specified by:
    `copyout` in interface `Accessor`
  Parameters:
    `origin` - int array specifying the starting index.
    `shape` - int array specifying the extents in each dimension. This becomes the shape of the return.
  Returns:
    the MultiArray with the specified shape
  See Also:
    `Accessor.copyout(int[], int[])`

### copyin

    public void copyin(int[] origin,
                       MultiArray data)
                throws IOException

  Description copied from interface: `Accessor`
  Aggregate write access. Given a MultiArray, copy it into this at the specified starting index. TODO: clearer specification.

  Hopefully this member can be optimized in various situations.

  `assert(origin[ii] + (source.getLengths())[ii] <= (getLengths())[ii]);`

  Specified by:
    `copyin` in interface `Accessor`
  Parameters:
    `origin` - int array specifying the starting index.
    `data` - MultiArray with the same componentType as this and shape smaller than `this.getLengths() - origin`
  Throws:
    `IOException`
  See Also:
    `Accessor.copyin(int[], ucar.multiarray.MultiArray)`

### toArray

    public Object toArray()

  Description copied from interface: `Accessor`
  Returns a new array containing all of the elements in this MultiArray. The returned array is one dimensional. The order of the elements in the result is natural, as if we used an IndexIterator to step through the elements of this MultiArray. The component type of the result is the same as this.

  This method acts as bridge between array-based and MultiArray-based APIs.

  This method is functionally equivalent to

                      Object anArray = Array.newInstance(getComponentType(), 1);
                      int [] origin = new int[getRank()]
                      int [] shape = getDimensions();
                      return toArray(anArray, origin, shape);

  Specified by:
    `toArray` in interface `Accessor`
  Returns:
    a one dimensional Array containing all the elements in this MultiArray
  See Also:
    `Accessor.toArray()`

### getStorage

    public Object getStorage()

  Specified by:
    `getStorage` in interface `MultiArray`
  Returns:
    a the original one dimensional Array containing all the elements in this MultiArray

### toArray

    public Object toArray(Object dst,
                          int[] origin,
                          int[] shape)

  Description copied from interface: `Accessor`
  Returns an array containing elements of this MultiArray specified by origin and shape, possibly converting the component type. The returned array is one dimensional. The order of the elements in the result is natural, as if we used an IndexIterator to step through the elements of this MultiArray.

  The anArray argument should be an array. If it is large enough to contain the output, it is used and no new storage is allocated. Otherwise, new storage is allocated with the same component type as the argument, and the data is copied into it.

  This method acts as bridge between array-based and MultiArray-based APIs.

  This method is similar to copyout(origin, shape).toArray(), but avoids a copy operation and (potentially) an allocation.

  NOTE: Implementation of type conversion is deferred until JDK 1.2. Currently, the componentType of `anArray` must be the same as `this`

  Specified by:
    `toArray` in interface `Accessor`
  Returns:
    a one dimensional Array containing the specified elements
  See Also:
    `Accessor.toArray()`

### truncCopy

    static int[] truncCopy(int[] src)

### get

    public Object get(int index)

  Peel the array by fixing the leftmost index value to the argument. Reduces rank by 1. If the result would be of primitive type, it is appropriately wrapped.

  Returns:
    Object value at `index`

### getLeaf

    public Object getLeaf(int[] index)

  Get the leaf array at Index.

### main

    public static void main(String[] args)